SRM 638 took place in the middle of the night in my time zone, so I didn't participate.

While I haven't read problems from my division (Div 1) yet, I decided to write an editorial for a whole Div 2 problem set.

One interesting thing is that first two problems can be solve very very fast in python, so having an ability to code in python can be a great advantage during live contest.

1000 problem was solved only by 3 users during the contest so I will give you a really simple method to implement it.

## 250 Problem // NamingConvention

#### Problem statement

This is really simple. You are given a string consisting of lowercase letters a-z and underscores '_', where underscores divide consecutive words and there is at least one letter between two underscores. The task is to convert the given string into camel case notation, i.e. first word is written in lower case and every other word starts with a capital letter while other letters are lower case.

The full problem statement is available here: http://community.topcoder.com/stat?c=problem_statement&pm=13521&rd=16081

#### Solution

You can split the string by underscores and capitalize the first letter of each word starting from the second one. Print resulting words one by one. In python this is so simple:

class NamingConvention: def toCamelCase(self, variableName): s = variableName.split('_') return "".join([s[0]] + map(lambda x: x.title(), s[1:])) |

The title() method of the class string class is very useful here. The solution has of course linear time complexity.

## 500 Problem // NarrowPassage2Easy

#### Problem statement

You are given an array of size at most , where every element is a positive integer not greater than . You are also given a positive integer not greater than .

The task is to count the number of different orders of (like permutations, but two elements with same value are considered different) for which there are no elements , such that and was before in the original array.

The full problem statement is available here: http://community.topcoder.com/stat?c=problem_statement&pm=13295&rd=16081

#### Solution

Since the array has at most 6 elements, we can consider every possible ordering and for each one check if there is a pair of elements, for which the condition from the problem statement is invalid. If there is no such pair, then we count this ordering as a valid and at the end we return the number of valid orderings. Again python makes it so easy to implement:

class NarrowPassage2Easy: def count(self, A, K): from itertools import permutations cnt = 0 n = len(A) for p in permutations(enumerate(A)): fail = 0 for i in range(n): for j in range(i + 1, n): if p[i][0] > p[j][0] and p[i][1] + p[j][1] > K: fail = 1 if not fail: cnt += 1 return cnt |

If you haven't heard about enumerate() function this is the time to read about it. Time complexity of this method is where is the size of the input array and since it is enough here.

## 1000 Problem // CandleTimerEasy

#### Problem statement

You are given a tree consisting of nodes. Each edge in the tree has a positive length of at most units.

You can ignite any **subset** of leaves in the tree. When a node is ignited, all edges adjacent to it starts burning, and if the fire meets another node , it becomes ignited and the process continues. The whole process lasts until all edges are burned.

Edges burn at a uniform rate. This means that if you ignite an edge of length at one end, it will burn in units of time, but if you place fire at its both ends, it will burn quicker (for example, if you place it in the same time, it will burn after units of time).

The tree is burned if all its edges are burned.

The task is count the number of different times in which the tree can be burned completely. These times may differ if you ignite different subsets of leaves at the beginning.

The full problem statement is available here: http://community.topcoder.com/stat?c=problem_statement&pm=13519&rd=16081

#### Solution

Since is at most here, we can try to ignite all subsets of leaves and for each one count the time in which the tree will burn completely.

At first I thought about simulating the process of burning, but it can be quite complex to implement, so I developed a solution very easy to code.

Let be the time in which is ignited when you ignite only at the beginning. In other words, is a distance between and where is a leaf in the tree. You can compute table using dfs for example.

Next we iterate over all subset of ignited leaves. I will show how to count the burning time for a given subset of size .

Let be the time when a node is ignited. We ignite at the beginning all leaves from . You can thing of this process as of different fire flames spreading on the tree. Node will be ignited by one of these flames. Which one? The one which comes to first and since we have our table computed, we can compute .

Now we know for any node in the tree. Since the tree is burned when all its edges are burned, we iterate over all edges and for each edge we find the time after it becomes completely burned based on values and .

Time complexity of this method is where is the number of leaves in the tree and is the number of all nodes in it.

I attached my C++ code below:

const int MAX_N = 20; vi g[MAX_N]; int w[MAX_N][MAX_N]; vi leaves; int fire1[MAX_N]; int fire2[MAX_N][MAX_N]; void dfs(int v, int p, int len, int root) { fire2[v][root] = len; FOR(i, SZ(g[v])) { int u = g[v][i]; if(u == p) continue; dfs(u, v, len + w[v][u], root); } } class CandleTimerEasy { public: int differentTime(vector A, vector B, vector len) { int n = SZ(A) + 1; FOR(i, n) g[i].clear(); leaves.clear(); FOR(i, n - 1) { g[A[i]].pb(B[i]); g[B[i]].pb(A[i]); w[B[i]][A[i]] = len[i]; w[A[i]][B[i]] = len[i]; } FOR(i, n) if(SZ(g[i]) == 1) leaves.pb(i); set ans; FOR(i, n) dfs(i, i, 0, i); for(int b = 1; b < (1 << SZ(leaves)); ++b) { int k = b; int c = 0; vector vs; while(k > 0) { int v = leaves[c]; if(k & 1) vs.pb(v); k /= 2; ++c; } FOR(i, n) fire1[i] = INF; FOR(v, n) { FOR(i, SZ(vs)) { int r = vs[i]; REMIN(fire1[v], fire2[v][r]); } } double res = 0; FOR(v, n) { FOR(i, SZ(g[v])) { int u = g[v][i]; double burned = min(fire1[v], fire1[u]) + w[v][u]; int dif = abs(fire1[v] - fire1[u]); REMIN(burned, min(fire1[v], fire1[u]) + dif + (w[v][u] - dif) / 2.0); REMAX(res, burned); } } ans.insert(res); } return SZ(ans); } }; |